ALTER TABLE admin_access ADD blog INT( 1 ) NOT NULL DEFAULT '0';
UPDATE admin_access SET blog = '1' WHERE customers_id = '1';

ALTER TABLE categories_description ADD categories_url_alias VARCHAR( 64 ) NOT NULL ;
ALTER TABLE products_description ADD products_url_alias VARCHAR( 64 ) NOT NULL ;
ALTER TABLE content_manager ADD content_url_alias VARCHAR( 64 ) NOT NULL ;
ALTER TABLE orders ADD ibn_billnr INT NOT NULL;
ALTER TABLE orders ADD ibn_billdate INT NOT NULL;
ALTER TABLE orders ADD ibn_pdfnotifydate INT NOT NULL;

CREATE TABLE blog_categories (
  id INT(11) NOT NULL AUTO_INCREMENT,
  categories_id INT(5) NOT NULL,
  language_id INT(11) NOT NULL DEFAULT '0',
  titel VARCHAR(150) NOT NULL DEFAULT '',
  status INT(1) NOT NULL DEFAULT '0',
  position INT(11) NOT NULL DEFAULT '0',
  date VARCHAR(10) NOT NULL,
  update_date VARCHAR(10) NOT NULL,
  meta_title text,
  meta_desc text,
  meta_key text,
  PRIMARY KEY  (id,language_id)
);


CREATE TABLE blog_comment (
  id INT(3) NOT NULL AUTO_INCREMENT,
  blog_id INT(11) NOT NULL,
  name VARCHAR(150) NOT NULL DEFAULT '',
  text text,
  date VARCHAR(10) NOT NULL,
  PRIMARY KEY  (id)
);

CREATE TABLE blog_items (
  id INT(11) NOT NULL AUTO_INCREMENT,
  item_id INT(5) NOT NULL,
  language_id INT(11) NOT NULL DEFAULT '0',
  categories_id INT(11) NOT NULL DEFAULT '0',
  title VARCHAR(150) NOT NULL DEFAULT '',
  name VARCHAR(200) NOT NULL DEFAULT '',
  description text NOT NULL,
  status INT(1) NOT NULL DEFAULT '0',
  position INT(11) NOT NULL DEFAULT '0',
  date VARCHAR(10) NOT NULL,
  date_update VARCHAR(10) NOT NULL,
  meta_title text,
  meta_keywords text,
  meta_description text,
  lenght INT(5) DEFAULT NULL,
  PRIMARY KEY  (id,language_id)
);

CREATE TABLE blog_settings (
  id INT(11) NOT NULL auto_increment,
  blog_key VARCHAR(20) DEFAULT NULL,
  wert VARCHAR(20) DEFAULT NULL,
  PRIMARY KEY  (id)
);

CREATE TABLE blog_start (
id INT(1) NOT NULL DEFAULT '0',
language_id INT(11) NOT NULL DEFAULT '0',
description TEXT NOT NULL,
date DATETIME NOT NULL,
PRIMARY KEY (id,language_id)
);

CREATE TABLE blog_vote (
  id INT(4) NOT NULL auto_increment,
  blog_id INT(8) NOT NULL,
  vote_nr INT(8) NOT NULL,
  img_nr VARCHAR(100) DEFAULT NULL,
  PRIMARY KEY  (id)
);


CREATE TABLE orders_pdf_profile (
  id int(11) unsigned NOT NULL AUTO_INCREMENT,
  languages_id int(2) NOT NULL,
  pdf_key varchar(64) NOT NULL,
  pdf_value varchar(264) NOT NULL,
  type varchar(32) NOT NULL,
  PRIMARY KEY (id)
);

CREATE TABLE orders_pdf (
	id int(11) unsigned NOT NULL AUTO_INCREMENT,
	order_id int(6) NOT NULL,
	pdf_bill_nr int(5) NOT NULL,
	bill_name varchar(128) NOT NULL,
	customer_notified int(1) NOT NULL,
	notified_date date NOT NULL,
	pdf_generate_date date NOT NULL,
	PRIMARY KEY (id)
);

DROP TABLE IF EXISTS commerce_seo_url_names;
CREATE TABLE IF NOT EXISTS commerce_seo_url_names (
  id INT(4) NOT NULL auto_increment,
  file_name VARCHAR(64) NOT NULL,
  file_name_php VARCHAR(32) NOT NULL,
  PRIMARY KEY (id)
);

DROP TABLE IF EXISTS commerce_seo_url_personal_links;
CREATE TABLE IF NOT EXISTS commerce_seo_url_personal_links (
  link_id INT(4) NOT NULL auto_increment,
  url_text VARCHAR(128) NOT NULL,
  file_name VARCHAR(64) NOT NULL,
  language_id INT(2) NOT NULL,
  PRIMARY KEY (link_id)
);

INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_ACCOUNT', 'account.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT_SHIPPING', 'checkout_shipping.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT', 'checkout.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_SHOPPING_CART', 'shopping_cart.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_SPECIALS', 'specials.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PRODUCTS_NEW', 'products_new.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_ADVANCED_SEARCH', 'advanced_search.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_LOGIN', 'login.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_LOGOFF', 'logoff.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PASSWORD_DOUBLE_OPT', 'password_double_opt.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_WISH_LIST', 'wish_list.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_NEWSLETTER', 'newsletter.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_ACCOUNT_EDIT', 'account_edit.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_ADDRESS_BOOK', 'address_book.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT_CONFIRMATION', 'checkout_confirmation.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT_PAYMENT', 'checkout_payment.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT_PAYMENT_ADDRESS', 'checkout_payment_address.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT_SHIPPING_ADDRESS', 'checkout_shipping_address.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CHECKOUT_SUCCESS', 'checkout_success.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_CREATE_ACCOUNT', 'create_account.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_DOWNLOAD', 'download.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PRINT_PDF', 'print_pdf.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_POPUP_CONTENT', 'popup_content.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_REVIEWS', 'reviews.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_POPUP_SEARCH_HELP', 'popup_search_help.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PRODUCT_REVIEWS', 'product_reviews.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PRODUCT_REVIEWS_INFO', 'product_reviews_info.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PRODUCT_REVIEWS_WRITE', 'product_reviews_write.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_ACCOUNT_HISTORY', 'account_history.php');
INSERT INTO commerce_seo_url_names VALUES ('', 'FILENAME_PRINT_PRODUCT_INFO', 'print_product_info.php');

INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('1','1','TEXT_PDF_HEADER','Shopname und kurzer Slogan','input');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('2','1','TEXT_PDF_ANSCHRIFT','Anschrift:\r\nMax Mustermann\r\nStrasse 12\r\n12345 Stadt\r\nDeutschland','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('3','1','TEXT_PDF_KONTAKT','Kontakt:\r\ninfo@AdresseDesShops.de','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('4','1','TEXT_PDF_BANK','Bankverbindung:\r\nInhaber: Max Mustermann\r\nKonto: 123456789  BLZ: 250 501 10\r\nBank: Deutsche Bank  BIC/Swift: XXXXXXX\r\nIBAN: XXXXXXX','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('5','1','TEXT_PDF_GESCHAEFT','Geschäftsinhaber:\r\nMax Mustermann\r\nUSt.IdNr.: DE12356789','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('6','1','TEXT_PDF_SHOPADRESSEKLEIN','AdresseDesShops.de - Max Mustermann - Strasse 12, 12345 Stadt','input');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('7','1','TEXT_PDF_DANKE_MANN','Sehr geehrter Herr %s,\r\nwir freuen uns, dass Sie bei XXXX bestellt haben.','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('8','1','TEXT_PDF_DANKE_FRAU','Sehr geehrte Frau %s,\r\nwir freuen uns, dass Sie bei XXXX bestellt haben.','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('9','1','TEXT_PDF_DANKE_UNISEX','Sehr geehrter Kunde / sehr geehrte Kundin,\r\nwir freuen uns, dass Sie bei XXXX bestellt haben.','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('10','1','TEXT_PDF_SCHLUSSTEXT','Vielen Dank für Ihren Auftrag!\r\n\r\nBesuchen Sie uns wieder unter XXXX!\r\n\r\n\r\nLeistungsdatum entspricht Rechnungsdatum.\r\nEs gelten unsere Allgemeine Geschäfts- und Lieferbedingungen.','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('11','1','TEXT_PDF_FILE_NAME','Rechnung_Nr#rn#','input');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('12','1','TEXT_PDF_DELIVERY_SCHLUSSTEXT','Vielen Dank für Ihren Auftrag. Ihre Ware wurde mit #vm# versendet.','textarea');
INSERT INTO orders_pdf_profile (id,languages_id,pdf_key,pdf_value,type) VALUES ('13','1','TEXT_PDF_DELIVERY_FILE_NAME','Lieferschein_#bn#_#vn#_#nn#_#d#','input');

INSERT INTO boxes VALUES (NULL, 'blog', 'links', 4, 1, 'file', 0);
INSERT INTO boxes VALUES (NULL, 'blog_archiv', 'links', 5, 1, 'file', 0);

INSERT INTO boxes_names VALUES ('', 'blog', 'Shop-Blog', '', 1, 1);
INSERT INTO boxes_names VALUES ('', 'blog_archiv', 'Blog-Archiv', '', 1, 1);

INSERT INTO blog_settings VALUES (NULL, 'social', 'ja');
INSERT INTO blog_settings VALUES (NULL, 'comments', 'ja');
INSERT INTO blog_settings VALUES (NULL, 'rate', 'nein');
INSERT INTO blog_settings VALUES (NULL, 'register_user', 'ja');
INSERT INTO blog_settings VALUES (NULL, 'session_rate', 'ja');
INSERT INTO blog_settings VALUES (NULL, 'blog_nav_ajax', 'nein');
INSERT INTO blog_settings VALUES (NULL, 'blog_captcha', 'nein');




INSERT INTO emails VALUES (NULL, 'pdf_mail', 1,'{$shop_name}','PDF Rechnung von {$store_name} für Ihre Bestellung','{$shop_name}','','Ihre PDF-Rechnung vom {$date}','','<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\r\n<html xmlns=\"http://www.w3.org/1999/xhtml\" dir=\"ltr\" xml:lang=\"de\" lang=\"de\">\r\n<head>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" />\r\n<title>PDF-Rechnung</title>\r\n{literal}\r\n<style type=\"text/css\"> \r\nbody, table {font-size:11.5px; font-family:Helvetica, sans-serif;color:#444}\r\ntable.outerTable {border: 1px solid #ccc}\r\ntd.TopRightDesc {letter-spacing: 1px; font-weight: 600}\r\n.ProductsTable td {color:#6d88b1;background: #f1f1f1}\r\n.ProductsAttributes td, .ProductsName {background: #ffffff}\r\n.lightBackground td {color:#6d88b1;background: #f1f1f1}\r\n.bt {border-top:1px solid #ccc}\r\n.bb {border-bottom:1px solid #ccc}\r\n.bl {border-left:1px solid #ccc}\r\n.br {border-right:1px solid #ccc}\r\n.fs85 {font-size:85%}\r\n</style>\r\n{/literal}\r\n</head>\r\n<body>\r\n<table width=\"90%\" border=\"0\" cellpadding=\"10\" cellspacing=\"0\" align=\"center\" class=\"outerTable\">\r\n  <tr>\r\n    <td>\r\n      <table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\r\n        <tr>\r\n          <td width=\"50%\">\r\n            <img src=\"{$logo_path}logo.gif\" alt=\"\" />\r\n          </td>\r\n          <td width=\"50%\" class=\"TopRightDesc\" align=\"right\">\r\n            PDF-Rechnung\r\n          </td>\r\n        </tr>\r\n      </table>\r\n    </td>\r\n  </tr>\r\n  <tr>\r\n    <td>\r\n      <table width=\"100%\" border=\"0\" cellspacing=\"6\" cellpadding=\"3\" class=\"outerTable\">\r\n         <tr>\r\n           <td colspan=\"2\">\r\n                <p><strong>Sehr geehrter Kunde, </strong></p>\r\n             <p>im Anhang dieser E-Mail übermitteln wir Ihnen die Rechnung Ihrer Bestellung vom {$ORDER_DATE}.<br /><br />               Bei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese eMail.</p>\r\n              </td>\r\n          </tr>\r\n        <tr class=\"lightBackground\">\r\n          <td>\r\n            Den Status Ihrer Bestellung können Sie einsehen  unter:\r\n          </td>\r\n          <td>\r\n            <a href=\"{$ORDER_LINK}\">{$ORDER_LINK}</a>\r\n          </td>\r\n        </tr>\r\n       </table>\r\n    </td>\r\n  </tr>\r\n</table>','Sehr geehrter Kunde,\r\n\r\nim Anhang dieser E-Mail übermitteln wir Ihnen die Rechnung Ihrer Bestellung vom {$ORDER_DATE}.\r\n\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese eMail, den Status Ihrer Bestellung können \r\nSie einsehen unter: {$ORDER_LINK}.','Sehr geehrter Kunde, \r\n      \r\n\r\nim Anhang dieser E-Mail übermitteln wir Ihnen die Rechnung Ihrer Bestellung vom {$ORDER_DATE}.            \r\n                                                                                                          \r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese eMail. Den Status Ihrer Bestellung können     \r\nSie einsehen unter: {$ORDER_LINK}.','Sehr geehrter Kunde,\r\n\r\nim Anhang dieser E-Mail übermitteln wir Ihnen die Rechnung Ihrer Bestellung vom {$ORDER_DATE}.\r\n\r\nBei Fragen zu Ihrer Bestellung antworten Sie bitte auf diese eMail, den Status Ihrer Bestellung können \r\nSie einsehen unter: {$ORDER_LINK}.',1263483589);

